// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 28 noviembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// CDTJ ColganteDecorativoToallasJabon
// El archivo dibuja un Set para colgar toallas y otros artefactos
// de limpieza personal
// La siguiente es la lista de macros basicas con las dimensiones
// Todos los objetos se dibujan inicialmente sobre el plano XZ,
//      El frente hacia Z-, gravedad hacia Y-.
// #macro CDTJ_CirculoToallaBasico( Angulo )
//      Angulo                  : Angulo en eje X para rotar el aro
//                                hacia el frente del colgante
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad en Z        = 55*L
//      Radio Aro               = 55*L
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_CirculoToalla( BaseRadio, BaseAlto, RadioAro, AnguloGiro,
//                  TexturaMetal, TexturaBlanca, TexturaPlastica )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      RadioAro                : Valor referencia para el radio
//                                del aro.  Default es 55*L.
//      AnguloGiro              : Giro del aro en grados hacia el frente.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaPlastica         : Textura a aplicar a la zona de friccion
//                                del aro.
//                                Default es GMGE_DefaultTexturaPlastica.
//
// #macro CDTJ_SoporteToallaBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad en Z        = 55*L
//      Largo Total             = 485*L
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_SoporteToalla( BaseRadio, BaseAlto, LargoSoporte,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      LargoSoporte            : Valor del largo del colgante.
//                                Default es 430*L.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar a la barra.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_SoporteRopaBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad total en Z  = 55*L
// Desciende 42*L en Y- desde el centro de la base.
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_SoporteRopa( BaseRadio, BaseAlto, ProfundidadRopa,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      ProfundidadRopa         : Valor referencia para el colgante.
//                                Default es 50*L.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar al colgante.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_SoporteCepilloBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad en Z        = 95*L
//      Ancho soporte cepillos  = 70*L
// Con aberturas para cuatro cepillos dentales corrientes.
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_SoporteCepillo( BaseRadio, BaseAlto, DimensionSoporte,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      DimensionSoporte        : Valor refencia para el soporte
//                                de cepillos dentales.
//                                Default es 71*L
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar en la base de cepillos.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_HBasico()
// Caracteristicas
//      DiametroBase            = 55*L
//      Profundidad total Z     = 100*L
//      Ancho total             = 105*L
// Descenso 65*L en Y- a partir del centro.
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_H( BaseRadio, BaseAlto, DimensionH, GruesoH, AnguloVarilla,
//                  AnguloCubrir,
//                  TexturaMetal, TexturaBlanca, TexturaAuxiliar )
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      DimensionH              : Referencia para el ancho.
//                                Default es 100*L.
//      GruesoH                 : Referencia para el grueso.
//                                Default es 60*L.    
//      AnguloVarilla           : Angulo de giro de la varilla 
//                                a partir de posicion base.
//                                Default es 0.
//      AnguloCubrir            : Angulo de giro de los protectores 
//                                metalicos a partir de posicion base.
//                                Default es 0.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaAuxiliar         : Textura a aplicar a la placa protectora.
//                                Default es GMGE_DefaultTexturaMetal.
//
// #macro CDTJ_JaboneraBasico( VasoVisible )
//      VasoVisible             : on dibuja el vaso
//                                off no lo dibuja
// Caracteristicas
//      Diametro Base           = 55*L
//      Profundidad Total Z     = 95*L
//      Radio Soporte Vaso      = 44*L
//      Alto Vaso               = 67*L
//
// Puede dibujarse tambien con la siguiente macro
// #macro CDTJ_Jabonera( VasoVisible, BaseRadio, BaseAlto, RadioSoporte,
//                  AltoVaso, TexturaMetal, TexturaBlanca, TexturaVaso )
//      VasoVisible             : on dibuja el vaso
//                                off no lo dibuja
//      BaseRadio               : Valor referencia para el radio
//                                de la base. Default es 22.5*L.
//      BaseAlto                : Valor referencia para la
//                                expansion Z de la base.
//                                Default es 21*L.
//      RadioSoporte            : Valor referencia para el radio del vaso.
//                                Default es 21*L.
//      AltoVaso                : Valor del alto del vaso.
//                                Default es 67*L.
//      TexturaMetal            : Textura a aplicar a zonas metalizadas.
//                                Default es GMGE_DefaultTexturaMetal.
//      TexturaBlanca           : Textura a aplicar a la base.
//                                Default es GMGE_DefaultTexturaBlanca.
//      TexturaVaso             : Textura a aplicar al vaso.
//                                Default es GMGE_DefaultTexturaVaso.
//
// Estas son variables predefinidas que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare CDTJ_TexturaMetal           = texture { ... }
//      Textura principal a aplicar a los soportes.
//      Se utilizara en la mayoria de las texturas auxiliares.
// #declare CDTJ_TexturaBlanca          = texture { ... }
//      Textura a aplicar a los soportes.
// #declare CDTJ_TexturaPlastica        = texture { ... }
//      Textura adicional para la zona de friccion entre
//      el aro para toallas y su soporte.
// #declare CDTJ_TexturaVaso            = texture { ... }
//      Textura a aplicar al vaso.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario
// #declare CDTJ_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no cumple ninguna funcion.
// #declare CDTJ_DefaultTexturaMetal    = texture { ... }
//      Textura default principal a aplicar a los soportes.
//      Se utilizara en la mayoria de las texturas auxiliares.
// #declare CDTJ_DefaultTexturaBlanca   = texture { ... }
//      Textura default a aplicar a los soportes.
// #declare CDTJ_DefaultTexturaPlastica = texture { ... }
//      Textura default adicional para la zona de friccion entre
//      el aro para toallas y su soporte.
// #declare CDTJ_DefaultTexturaVaso     = texture { ... }
//      Textura default a aplicar al vaso.
//
// Para colocarlo simplemente
// #include "CDTJ.inc"
// object { CDTJ_JaboneraBasico( on ) }
//
// Otro ejemplo con modificador
// #include "CDTJ.inc"
// #declare CDTJ_DefaultTexturaBlanca           = texture       {
//   PinkAlabaster
// }
// #declare CDTJ_DefaultTexturaMetal            = texture       {
//   average
//   texture_map        {
//     [ 0.5 CDTJ_TexturaMetal          ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// object               {
//   CDTJ_SoporteToallaBasico()
// }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White*0.8
}
light_source    {
         <-500  , 500   , -3000 >*L
         White*0.8
}
background      {
         Gray50
}

#include "CDTJ.inc"

#local FactorAcercamiento       = 3;
union           {
  object        {
    CDTJ_CirculoToallaBasico( 0 )
    translate   -100*L*x+ 50*L*y
  }
  object        {
    CDTJ_SoporteToallaBasico()
    translate   +  0*L*x+125*L*y
  }
  object        {
    CDTJ_SoporteRopaBasico()
    translate   -150*L*x-125*L*y
  }
  object        {
    CDTJ_SoporteCepilloBasico()
    translate   +  0*L*x-125*L*y
  }
  object        {
    CDTJ_HBasico()
    translate   +150*L*x-100*L*y
  }
  object        {
    CDTJ_JaboneraBasico( on )
    translate   +100*L*x+  0*L*y
  }
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z  
}


