// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 octubre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// EJNN ExprimidorJugosNaranjaNatural
// El archivo dibuja un exprimidor de jugos
// en posicion default con la macro
// #macro EJNN_ExprimidorJugosNaranjaNatural( BanderaExprimidor )
//      BanderaExprimidor       : true se dibuja un exprimidor de jugos
//                                false elimina los elementos peculiares
//                                del exprimidor, para adaptarse
//                                a otros usos
// Las caracteristicas serian
//      Altura Pichel sin tapa  : 75*L
//      Altura Base             : 37.5*L
//      Altura Total con tapa   : 134.5*L
//      Radio principal         : 58*L (sin agarradera)
// La base del pichel se encuentra sobre el plano XY,
// La tapa hacia Y+, y la base hacia Y-
// La boquilla hacia X-, y la agarradera hacia X+
//
// Los elementos del exprimidor se pueden dibujar con
// macros independientes, que los coloca
// en la misma posicion del dibujo inicial
//
// El pichel sin tapa puede dibujarse con
// #macro EJNN_Pichel( Diametro, Alto, DiametroInterior,
//                TexturaTransparente, BanderaExprimidor )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//      DiametroInterior        : Aproxima el diametro del
//                                cilindro interior de agitacion
//                                cota inferior
//      TexturaTransparente     : Textura a aplicar al pichel
//      BanderaExprimidor       : true lo dibuja como exprimidor
//                                false lo dibuja como pichel comun
//
// La tapa del pichel, se dibuja con la siguiente macro,
// se coloca en la misma posicion que el dibujo...
// #macro EJNN_TapaPichel( Diametro, Alto, TexturaTransparente )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//                                (del pichel NO la tapa)
//      TexturaTransparente     : Textura a aplicar al pichel
//
// La base solo bajo el plano XY se dibuja con...
// #macro EJNN_BasePichel( Diametro, Alto, DiametroGiro, AltoBase,
//             TexturaBase, TexturaBarata, TexturaPatita, BanderaExprimidor )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//      DiametroGiro            : Aproxima el diametro del
//                                cilindro interior de agitacion
//                                cota superior
//      AltoBase                : Alto total de la base
//      TexturaBase             : Textura a aplicar a la base
//      TexturaBarata           : Textura a aplicar al soporte
//                                superior de giro
//      TexturaPatita           : Textura a aplicar a las patitas
//                                cilindricas inferiores
//      BanderaExprimidor       : true lo dibuja como exprimidor
//                                false lo dibuja como base simple
//
// #macro EJNN_FiltroJugo( Diametro, Alto, DiametroFiltro,
//                        DiametroGiro, TexturaFiltroJugo )
//      Diametro                : Aproxima el diametro principal del pichel
//                                sin agarradera
//      Alto                    : Alto del pichel sin tapa
//      DiametroFiltro          : Aproxima el diametro del filtro
//                                de rotacion
//      DiametroGiro            : Aproxima el diametro del
//                                cilindro interior de agitacion
//                                cota superior
//      TexturaFiltroJugo       : Textura a aplicar al filtro de rotacion
//
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse
// Si quiere modificarlas, recurra a los modificadores
// #declare EJNN_VolumenJugo            = Sirve para agregar jugo
//      al pichel.  Se genera automaticamente con las macros de pichel
//      intersection { object { EJNN_VolumenJugo } object{ ... } }
// #declare EJNN_TexturaTransparente    = texture { ... }
//      Textura a aplicar al pichel y la tapa
// #declare EJNN_TexturaBase            = texture { ... }
//      Textura a aplicar a la base
// #declare EJNN_TexturaBarata          = texture { ... }
//      Textura a aplicar al extremo superior del cilindro de giro
// #declare EJNN_TexturaFiltroJugo      = texture { ... }
//      Textura a aplicar al filtro de giro
// #declare EJNN_TexturaPatita          = texture { ... }
//      Textura a aplicar a las patitas negras cilindricas
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare GSCA_POV3_1                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//      En esta version no tiene ningun efecto.
// #declare EJNN_TexturaTransparente            = texture { ... }
//      Textura a aplicar al pichel y la tapa
// #declare EJNN_DefaultTexturaBase             = texture { ... }
//      Textura a aplicar a la base
// #declare EJNN_DefaultTexturaBarata           = texture { ... }
//      Textura a aplicar al extremo superior del cilindro de giro
// #declare EJNN_DefaultTexturaFiltroJugo       = texture { ... }
//      Textura a aplicar al filtro de giro
// #declare EJNN_DefaultTexturaPatita           = texture { ... }
//      Textura a aplicar a las patitas negras cilindricas
//
// Para colocarlo simplemente
// #include "EJNN.inc"
// object { EJNN_ExprimidorJugosNaranjaNatural( true ) }
//
// Otro ejemplo con modificador
// #include "EJNN.inc"
// #declare EJNN_DefaultTexturaBase             = texture       {
//   PinkAlabaster
// }
// #declare EJNN_DefaultTexturaTransparente     = texture       {
//   average
//   texture_map        {
//     [ 0.5 EJNN_TexturaTransparente   ]
//     [ 0.5 Rust                       ]
//   }
// }
//
// union                {
//   object       { EJNN_ExprimidorJugosNaranjaNatural( false ) }
//   intersection       {
//     cylinder { 0, 20*L*y, 100*L }
//     object   { EJNN_VolumenJugo }
//     pigment  { Gray20           }
//   }
// }
//

#if ( version < 3.2 )
  #ifndef( EJNN_POV3_1 )
    #declare EJNN_POV3_1        = on;
  #end
#else
  #ifndef( EJNN_POV3_1 )
    #declare EJNN_POV3_1        = off;
  #end
#end

#declare EJNN_TexturaTransparente       = texture       {
  pigment               {
    rgbt        < 0.8, 1.0, 0.8, 0.8 >
  }
}

#ifndef ( EJNN_DefaultTexturaTransparente )
  #declare EJNN_DefaultTexturaTransparente      = texture       {
    EJNN_TexturaTransparente
  }
#end

#declare EJNN_TexturaBase                       = texture       {
  pigment               {
    Gray95
  }
}

#ifndef ( EJNN_DefaultTexturaBase )
  #declare EJNN_DefaultTexturaBase              = texture       {
    EJNN_TexturaBase
  }
#end

#declare EJNN_TexturaBarata                     = texture       {
  pigment               {
    White
  }
}

#ifndef ( EJNN_DefaultTexturaBarata )
  #declare EJNN_DefaultTexturaBarata            = texture       {
    EJNN_TexturaBarata
  }
#end

#declare EJNN_TexturaFiltroJugo                 = texture       {
  pigment               {
    White
  }
}

#ifndef ( EJNN_DefaultTexturaFiltroJugo )
  #declare EJNN_DefaultTexturaFiltroJugo        = texture       {
    EJNN_TexturaFiltroJugo
  }
#end

#declare EJNN_TexturaPatita                     = texture       {
  pigment               {
    Black
  }
}

#ifndef ( EJNN_DefaultTexturaPatita )
  #declare EJNN_DefaultTexturaPatita            = texture       {
    EJNN_TexturaPatita
  }
#end

#macro EJNN_Pichel( Diametro, Alto, DiametroInterior,
                TexturaTransparente, BanderaExprimidor )
  merge         {
    #declare EJNN_VolumenJugo   = difference    {
      cylinder          {
        0               , Alto*0.9*y        ,
        Diametro/2*0.98
      }
      cylinder          {
        0               , 0.035*Alto*y
        Diametro/2
      }
      #if ( BanderaExprimidor )
        cylinder          {
          0               , 0.95*Alto*y   ,
          DiametroInterior/2*1.04*1.02
        }
      #end
    }
    difference          {
      difference        {
        cylinder          {
          0               , Alto*y        ,
          Diametro
        }
        cylinder          {
          0.03*Alto*y     , 1.01*Alto*y   ,
          Diametro/2
        }
        #if ( BanderaExprimidor )
          cylinder          {
            -0.1*Alto*y     , 0.70*Alto*y   ,
            DiametroInterior/2
          }
        #end
        superellipsoid      {
          < 1.0,0.1 >
          scale     <0.5,1.0,0.4>*Alto/3
          rotate            -20*x
          translate         Alto*y-Diametro/2*z
        }
        plane             {
          -y              , 0
          rotate          -35*x
          translate       Alto*y-Diametro/2*z
        }
      }
      difference        {
        cylinder          {
          0               , Alto*y        ,
          Diametro
        }
        cylinder          {
          0.03*Alto*y     , 1.01*Alto*y   ,
          Diametro/2
        }
        superellipsoid      {
          < 1.0,0.1 >
          scale     <0.5,1.0,0.4>*Alto/3
          rotate            -20*x
          translate         Alto*y-Diametro/2*z
        }
        plane             {
          -y              , 0
          rotate          -35*x
          translate       Alto*y-Diametro/2*z
        }
        scale     1.04
        translate -1.04*0.03*Alto*y
      }
    }
    difference          {
      torus             {
        1.04*Diametro/2 , 0.01*Diametro
        translate       0.95*Alto*y
      }
      superellipsoid      {
        < 1.0,0.1 >
        scale     <0.5,1.0,0.4>*Alto/3
        rotate            -20*x
        translate         Alto*y-Diametro/2*z
      }
      torus             {
        Alto/2          , 0.9*Alto/5
        rotate          90*z
        scale             <1,1.2,0.5>
        translate         Alto/2*y+Diametro/2*z
        translate         -Diametro/2*z
        rotate            10*x
        translate         +Diametro/2*z
      }
    }
    difference          {
      difference          {
        torus             {
          Alto/2          , Alto/5
          rotate          90*z
          scale             <1,1.2,0.5>
          translate         Alto/2*y+Diametro/2*z
        }
        torus             {
          Alto/2          , 0.9*Alto/5
          rotate          90*z
          scale             <1,1.2,0.5>
          translate         Alto/2*y+Diametro/2*z
        }
        difference        {
          cylinder        {
            -Alto/2*x     , Alto/2*x      ,
            Alto
          }
          cylinder        {
            -Alto*x       , Alto*x        ,
            Alto/2
          }
          scale         <1,1.2,0.5>
          translate       Alto/2*y+Diametro/2*z
        }
        translate         -Diametro/2*z
        rotate            10*x
        translate         +Diametro/2*z
      }
      cylinder          {
        0               , 2*Alto*y      ,
        Diametro/2
      }
    }
    #if ( BanderaExprimidor )
      difference          {
        cylinder          {
          0               , 0.80*Alto*y   ,
          DiametroInterior/2*1.04
        }
        cylinder          {
          -0.1*Alto*y     , 0.90*Alto*y   ,
          DiametroInterior/2
        }
      }
    #end
    rotate              90*y
    texture             {
      TexturaTransparente
    }
  }
#end

#macro EJNN_TapaPichel( Diametro, Alto, TexturaTransparente )
  merge         {
    difference          {
      superellipsoid    {
        < 0.8, 1.0 >
        scale           <Diametro/2,Alto/6,Diametro/2>*1.04
      }
      superellipsoid    {
        < 0.8, 1.0 >
        scale           <Diametro/2,Alto/7,Diametro/2>
      }
      cylinder          {
        0               , Alto/3*y      ,
        Diametro/4
      }
      plane             {
        y               , 0
      }
    }
    difference          {
      superellipsoid    {
        < 0.3, 1.0 >
        scale           <Diametro/4,Alto/3.5,Diametro/4>*1.04
      }
      superellipsoid    {
        < 0.3, 1.0 >
        scale           <Diametro/4,Alto/3.8,Diametro/4>
      }
      plane             {
        y               , 0
      }
      superellipsoid    {
        < 0.8, 1.0 >
        scale           <Diametro/2,Alto/7,Diametro/2>
      }
    }
    difference          {
      cylinder          {
        0               , -0.03*Alto*y  ,
        Diametro/2
        scale   <1.08,1.0,1.08>
      }
      cylinder          {
        -0.015*Alto*y   , -0.04*Alto*y  ,
        Diametro/2
        scale   <1.04,1.0,1.04>
      }
      cylinder          {
        0.1*Alto*y      , -0.04*Alto*y  ,
        Diametro/2
      }
    }
    translate           1.015*Alto*y
    texture             {
      TexturaTransparente
    }
  }
#end

#macro EJNN_BasePichel( Diametro, Alto, DiametroGiro, AltoBase,
                TexturaBase, TexturaBarata, TexturaPatita, BanderaExprimidor )
  union                 {
    #local DiametroInterior     = DiametroGiro*0.85;
    #local RadioBordecillo      = 0.025*Diametro;
    difference          {
      cylinder          {
        0               , -AltoBase*0.85*y
        Diametro/2
      }
      torus             {
        Diametro/2      , RadioBordecillo
      }
      torus             {
        Diametro/2      , Diametro*0.005
        translate       -AltoBase*0.70*y
      }
    }
    #if ( BanderaExprimidor )
    cylinder            {
      0                 , 0.53*Alto*y           ,
      DiametroInterior*0.90*0.5
      texture           {
        TexturaBase
      }
    }
    cone                {
      0                 , DiametroInterior*0.5  ,
      DiametroInterior*0.5*y            , 0
      texture           {
        TexturaBase
      }
    }
    union               {
      cylinder          {
        0.4*Alto*y      , 0.55*Alto*y           ,
        DiametroInterior*0.5
      }
      cylinder          {
        0.5*Alto*y      , 0.57*Alto*y
        DiametroInterior*0.5*0.90
      }
      difference        {
        union           {
          sphere          {
            71/75*Alto*y  , DiametroInterior*0.5*0.90
          }
          cylinder      {
            0.50*Alto*y   , 71/75*Alto*y  ,
            DiametroInterior*0.5*0.90
          }
        }
        #local C        = 0;
        #while ( C < 4 )
          plane           {
            x             , 0
            translate   -DiametroInterior*0.5/sqrt(2)
            rotate      90*C*y
          }
          #local C      = C+1;
        #end
      }
      #local C          = 0;
      #while ( C < 2 )
        box           {
          <-DiametroInterior*0.5*0.85,0.5*Alto         ,
                                        -0.005*Alto>,
          <+DiametroInterior*0.5*0.85,65/75*Alto       ,
                                        +0.005*Alto>
          rotate      90*C*y
        }
        #local C        = C+1;
      #end
      texture           {
        TexturaBarata
      }
    }
    torus               {
      Diametro/2-RadioBordecillo            ,
      RadioBordecillo
      translate     -RadioBordecillo*y
    }
    #end
    superellipsoid      {
      <0.8,1.0>
      scale             < Diametro/2,AltoBase*0.10,Diametro/2>
      translate         -AltoBase*0.85*y
    }
    difference          {
      cylinder            {
        -0.95*AltoBase*y  , 0             ,
        Diametro/2*0.90
      }
      torus             {
        Diametro/2*0.90 , AltoBase*0.05
        translate       -0.95*AltoBase*y
      }
    }
    #local C            = 0;
    #while ( C < 3 )
      cylinder          {
        -0.1*AltoBase*y , -AltoBase*y   ,
        Diametro/2*0.1
        translate       +Diametro/2*0.75*x
        rotate          C*120*y
        texture         {
          TexturaPatita
        }
      }
      #local C          = C+1;
    #end
    scale               <1.04,1.00,1.04>
    texture           {
      TexturaBase
    }
  }
#end

#macro EJNN_FiltroJugo( Diametro, Alto, DiametroFiltro,
                        DiametroGiro, TexturaFiltroJugo )
  union                 {
    difference          {
      superellipsoid    {
        <0.5,1.0>
        scale           <DiametroFiltro/2,Alto/4,DiametroFiltro/2>
      }
      superellipsoid    {
        <0.5,1.0>
        scale           <DiametroFiltro/2,Alto/4,DiametroFiltro/2>
                            *<1/1.04,1/1.2,1/1.04>
      }
      #local TotFiltro  = 75;
      #local C          = 0;
      #while ( C < TotFiltro )
        box             {
          -1            ,1
          rotate        45*y
          scale         <Diametro/2/sqrt(2),Alto,0.007*Diametro>
          translate     -Diametro/2*x-Alto*y-Alto/16*y
          rotate        360/TotFiltro*C*y
        }
        #local C        = C+1;
      #end
      plane             {
        -y              , 0
      }
      cylinder          {
        -Alto*y         , Alto*y        ,
        DiametroFiltro/4
      }
      translate         64/75*Alto*y
    }
    difference          {
      sphere            {
        0               , 1
      }
      sphere            {
        0               , 0.5
      }
      #local C          = 0;
      #while ( C <8 )
        torus           {
          1             , 0.6/sqrt(2)
          rotate        90*z
          rotate        45*C*y
        }
        #local C        = C+1;
      #end
      plane             {
        y               , 0
      }
      scale             <DiametroFiltro/3,
                0.8*DiametroFiltro,DiametroFiltro/3>
      translate         64/75*Alto*y
      translate         -Alto/4*y+0.03*Alto*y
    }
    difference          {
      cylinder          {
        0.02*Alto*y     , 0.05*Alto*y
        DiametroFiltro/4
      }
      cylinder          {
        -0.01*Alto*y    , 0.06*Alto*y
        3*DiametroFiltro/16
      }
      translate         64/75*Alto*y
      translate         -Alto/4*y
    }
    texture           {
      TexturaFiltroJugo
    }
  }
#end

#macro EJNN_ExprimidorJugosNaranjaNatural( BanderaExprimidor )
  union           {
    #local L                      = 0.001;
    #local Diametro               = 110*L;
    #local DiametroInterior       = 0.15*Diametro;
    #local DiametroFiltro         = 100*L;
    #local Alto                   = 75*L;
    #local AltoBase               = Alto/2;
    object        {
      EJNN_Pichel( Diametro, Alto, DiametroInterior,
                  EJNN_DefaultTexturaTransparente, BanderaExprimidor )
    }
    object        {
      EJNN_TapaPichel( Diametro, Alto, EJNN_DefaultTexturaTransparente )
    }
    object        {
      EJNN_BasePichel( Diametro, Alto, DiametroInterior, AltoBase,
                  EJNN_DefaultTexturaBase,
                  EJNN_DefaultTexturaBarata,
                  EJNN_DefaultTexturaPatita, BanderaExprimidor )
    }
    #if ( BanderaExprimidor )
      object        {
        EJNN_FiltroJugo( Diametro, Alto, DiametroFiltro,
                    DiametroInterior, EJNN_DefaultTexturaFiltroJugo )
      }
    #end
  }
#end
