// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 24 junio 2011
//
// ADVERTENCIA: (todas las fuentes son legtimas y de libre uso comercial)
// Las macros EMBA_Reorient_Trans y EMBA_Axis_Rotate_Trans
// se transcribe casi identica a la original
// en "transforms.inc" Reorient_Trans y Axis_Rotate_Trans
// se copia por compatibilidad con POVRay 3.1.
// La macro EMBA_VPerp_To_Vector
// se tomo de "math.inc" VPerp_To_Vector
// por compatibilidad con POVRay 3.1.
// Otras fuentes:
// link_object (el elemento base de la cadena) fue transcrito
// con pocas modificaciones del archivo
// "fireplug.inc"
// Tomado de la Biblioteca de POVRAY administrada por Micha Riser
// autor Christophe Bouffartigue de fecha 3 Julio 2000
// email: christophe.bouffartigue@libertysurf.fr
// ademas se llama a "link.inc"
// "link.inc"
// Created by Chris Colefax, 20 April 1998
// archivo especializado para generar cadenas...
// puede obtenerse junto con "fireplug.inc" en la misma fuente
// FIN ADVERTENCIA
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// La macro EMBA_Escalera()
// Crea una escalera domestica parte alta orientada hacia y+,
// el centro de la base reposando cercano al origen.
// Las patas alineadas sobre el eje x.
// El frente en x+, y la base alta atravezada en su centro por el eje y.
// Altura Escalera      : 682*L
// Ancho Escalera       : 264*L
//      sin contar las cadenas de grosor 7*L cada una
// Profundidad Escalera : +296*L ( frente x+ )
//                        -234*L aprox    x-
// Plataforma Superior  : 144*L centrada en x
//
// El objeto puede generarse via una macro principal de texturas
// #macro EMBA_EscaleraMaderaBajaAltura
//        ( FraccionGiro, NumeroEscalones, FraccionGrada,
//              TexturaMadera, TexturaMaderaBarata, TexturaMetalica )
//      FraccionGiro            : permite abrir con 1.0 o cerrar 0.0 la
//              escalera, con sus fracciones.
//              La escalera se cierra paulatinamente, en forma
//              vertical utilizando de apoyo la pata delantera.
//      NumeroEscalones         : cambia el total de escalones.
//      FraccionGrada           : valor default es 1.0.  Permite cambiar
//              el ancho de la madera de los escalones.
//              Puede ser util si se quiere poner un elevado numero
//              de escalones.
//      TexturaMadera           : textura principal a aplicar a la estructura.
//      TexturaMaderaBarata     : textura a aplicar en las barras cruzadas
//              que soportan las patas moviles.
//      TexturaMetalica         : textura a aplicar en las cadenas y en
//              sujetadores metalicos de la escalera.
//
// Las siguientes variables no deberian modificarse
// EMBA_Escalones               = array [ NumeroEscalones+1 ]
//      Arreglo de vectores 3D con la ubicacin de la parte central
//      superior de las gradas.  EMBA_Escalones[ 0 ], es la base
//      superior.  El resto se numera desde abajo hacia arriba.
// EMBA_TexturaMadera
//      Define una textura principal a aplicar en la estructura.
// EMBA_TexturaMaderaBarata
//      Otra textura para aplicar en las barras cruzadas de soporte.
// EMBA_TexturaMetalica
//      Textura para aplicar en las zonas metalicas de la escalera.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare EMBA_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
// #declare EMBA_Link           = off;
//      Al activarse dibuja la cadena.  Por default no la dibuja.
//      El problema es la disponibilidad del archivo
//      "link.inc" de Chris Colefax, que no es compatible
//      con el nuevo standard de la biblioteca POV-Ray.
//      Puede conseguirse en la Biblioteca administrada
//      por Micha Riser.  Objeto "fireplug.inc".
// #declare EMBA_DefaultTexturaMadera           = texture ...
//      Define una textura default principal para aplicar a la escalera.
// #declare EMBA_DefaultTexturaMaderaBarata     = texture ...
//      Otra textura default para aplicar en las barras cruzadas de soporte.
// #declare EMBA_DefaultTexturaMetalica         = texture ...
//      Textura default de las estructuras metalicas.
//
// Para colocarlo simplemente
// #include "EMBA.inc"
// object { EMBA_Escalera() }
//
// Si dispone del archivo "link.inc", puede dibujar la cadena con:
// #declare EMBA_Link                   = on;
// #include "EMBA.inc"
// object { EMBA_Escalera() }
//
// Para el uso de la macro de texturas:
// #include "EMBA.inc"
// object {
//   EMBA_EscaleraMaderaBajaAltura( 0.0, 9, 0.3,
//      EMBA_DefaultTexturaMadera,
//      EMBA_DefaultTexturaMaderaBarata,
//      EMBA_DefaultTexturaMetalica )
// }
//
// Otro ejemplo con modificador
// #include "EMBA.inc"
// #declare EMBA_DefaultTexturaMetalica         = texture       {
//   average
//   texture_map        {
//     [ 0.5 RCPS_Rust                          ]
//     [ 0.5 RCPS_TexturaMetalica               ]
//   }
// }
// union        {
//   object       { EMBA_Escalera() }
//   sphere       { EMBA_Escalones[ 0 ]+0.03*y, 0.03 pigment { Blue } }
// }
//

#include "colors.inc"

#local EjeMejorado              = false;
#local OjoAbsoluto              = 256;
#local VecesCentroAbsoluto      = 10;
#local L                        = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

// #declare EMBA_Link              = on;
#include "EMBA.inc"

object          {
  EMBA_Escalera()
  translate     -350*L*y
  rotate        45*y
}



