// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 Octubre 2011
//
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El paquete ESCM.inc, ofrece los dibujos
// de interruptores, toma corriente y portabombilla simple
// ESCM_Interruptor( BanderaOn1, BanderaOn2 )
//      BanderaOn1      : on/off interruptor hacia x+
//      BanderaOn2      : on/off interruptor hacia x-
//              78*L Largo 50*L Alto
//              Frente :  5*L hacia z-
//              Descansa sobre el plano XY parte posterior lisa
// ESCM_InterruptorBola( BanderaOn )
//      BanderaOn       : on/off (encendido/apagado)
//              25*L Ancho 39*L Alto
//              Frente : 16*L hacia z-
//              Descansa sobre el plano XY parte posterior lisa
// ESCM_TomaCorriente()
//              78*L Largo 50*L Alto
//              Frente : 2.5*L
//              Descansa sobre el plano XY parte posterior lisa
// ESCM_PortaBombilla()
//              Radio   : 82*L
//              Alto    : 30*L hacia y+ parte posterior lisa
//              Descansa sobre el plano XZ parte posterior lisa
// Se ofrece la siguiente macro de texturas
// #macro ESCM_ElectricidadSigloCincoMil( Modelo, Largo, Ancho, Grueso,
//                TexturaPlastica, TexturaBoton,
//                TexturaBotonEncendido, TexturaBotonApagado,
//                TexturaMetal, BanderaOn1, BanderaOn2 )
//      Modelo          : se ofrecen las siguientes opciones
//              ESCM_ModeloInterruptorPlano
//              ESCM_ModeloInterruptorBola
//              ESCM_ModeloTomaCorriente
//              ESCM_ModeloPortaBombilla
//      Largo           : Aproxima la dimension en x total,
//      Ancho           : Aproxima la dimension en y total
//              excepto en el Portabombilla, que se refiere
//              al diametro del cilindro central           Relacionado con la dimension en z-
//              excepto en ESCM_ModeloPortaBombilla que es 
//      Grueso          : y+
//      TexturaPlastica : Textura Plastica principal a aplicar
//              a las estructuras
//      TexturaBoton    :
//              ESCM_ModeloInterruptorPlano  Boton
//              ESCM_ModeloInterruptorBola   Boton
//              ESCM_ModeloTomaCorriente     no aplica
//              ESCM_ModeloPortaBombillo     Interior plastico
//      TexturaBotonEncendido   :
//              ESCM_ModeloInterruptorPlano  Boton on
//              ESCM_ModeloInterruptorBola   Boton on
//              ESCM_ModeloTomaCorriente     Soporte plastico secundario
//              ESCM_ModeloPortaBombillo     Tornillo interior
//      TexturaBotonApagado     :
//              ESCM_ModeloInterruptorPlano  Boton off
//              ESCM_ModeloInterruptorBola   Boton off
//              ESCM_ModeloTomaCorriente     zona circular de conexion
//              ESCM_ModeloPortaBombillo     no aplica
//      TexturaMetalica         :
//              Para aplicar a zonas metalicas,
//              en el toma corriente, es el fondo oscuro.
//      BanderaOn1              :
//              Primera bandera de encendido para los interruptores
//              Interruptor en x+ si hay dos
//      BanderaOn2              :
//              Segunda bandera de encendido, util unicamente
//              para ESCM_ModeloInterruptorPlano interruptor en x-
//
// Las siguientes variables no deberian modificarse
// #declare ESCM_TexturaPlasticaInterruptor             = texture...
//      Textura plastica principal de las cuatro figuras
// #declare ESCM_TexturaBotonInterruptor                = texture...
//      Textura a aplicar a los botones de los interruptores
// #declare ESCM_TexturaBotonEncendidoInterruptor       = texture...
//      Textura a aplicar a la senal de encendido de los botones
// #declare ESCM_TexturaBotonApagadoInterruptor         = texture...
//      Textura a aplicar a la senal de apagado de los botones
// #declare ESCM_TexturaMetalicaInterruptor             = texture...
//      Textura metalica a aplicar a tornillos externos
//      tambien se aplica al contacto cilindrico de bombillo
// #declare ESCM_TexturaPlasticaTomaCorriente           = texture...
//      Textura plastica a aplicar al toma corriente
// #declare ESCM_TexturaFuenteTomaCorriente             = texture...
//      Textura para la zona lisa del contacto electrico
// #declare ESCM_TexturaPlasticaAuxiliarTomaCorriente   = texture...
//      Textura para el soporte plastico secundario
// #declare ESCM_TexturaMetalicaTomaCorriente           = texture...
//      Textura de fondo oscura
// #declare ESCM_TexturaAuxiliarTornilloPortaBombilla   = texture...
//      Textura de tornillo interior del portabombilla
// #declare ESCM_TexturaPlasticaAuxiliarPortaBombilla   = texture...
//      Textura plastica al interior del portabombilla
//
// La siguiente es la lista de los modificadores permitidos,
//      que tendran efecto en las macros default
// #declare ESCM_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1,
//      en algunas versiones se activa automaticamente
// #declare ESCM_DefaultTexturaPlasticaInterruptor              = texture
//      Default modificable de Textura
//      plastica principal de las cuatro figuras
// #declare ESCM_DefaultTexturaBotonInterruptor                 = texture
//      Default modificable de Textura
//      a aplicar a los botones de los interruptores
// #declare ESCM_DefaultTexturaBotonEncendidoInterruptor        = texture
//      Default modificable de Textura
//      a aplicar a la senal de encendido de los botones
// #declare ESCM_DefaultTexturaBotonApagadoInterruptor          = texture
//      Default modificable de Textura
//      a aplicar a la senal de apagado de los botones
// #declare ESCM_DefaultTexturaMetalicaInterruptor              = texture
//      Default modificable de Textura metalica a aplicar
//      a tornillos externos
//      tambien se aplica al contacto cilindrico de bombillo
// #declare ESCM_DefaultTexturaPlasticaTomaCorriente            = texture
//      Default modificable de Textura plastica 
//      a aplicar al toma corriente
// #declare ESCM_DefaultTexturaFuenteTomaCorriente              = texture
//      Default modificable de
//      Textura para la zona lisa del contacto electrico
// #declare ESCM_DefaultTexturaPlasticaAuxiliarTomaCorriente    = texture
//      Default modificable de Textura 
//      para el soporte plastico secundario
// #declare ESCM_DefaultTexturaMetalicaTomaCorriente            = texture
//      Default modificable de Textura de fondo oscura
// #declare ESCM_DefaultTexturaAuxiliarTornilloPortaBombilla    = texture
//      Default modificable de Textura 
//      de tornillo interior del portabombilla
// #declare ESCM_DefaultTexturaPlasticaAuxiliarPortaBombilla    = texture
//      Default modificable de Textura plastica 
//      al interior del portabombilla
//
// Para colocarlo simplemente
// #include "ESCM.inc"
// object { ESCM_Interruptor( on, off ) }
//
// Para el uso de la macro de texturas:
// #include "ESCM.inc"
// object {
//   ESCM_ElectricidadSigloCincoMil( GMGE_ModeloInterruptorPlano,
//                0.078, 0.05, 0.005, PinkAlabaster,
//                Rust, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, on, off }
//
// Otro ejemplo con modificador
// #include "ESCM.inc"
// #declare ESCM_DefaultTexturaPlasticaTomaCorriente    = texture {
//   average
//   texture_map        {
//     [ 0.5 Rust                               ]
//     [ 0.5 ESCM_TexturaPlasticaTomaCorriente  ]
//   }
// }
// object       { ESCM_TomaCorriente() }
//

#include "colors.inc"
#include "textures.inc"
#declare ESCM_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( ESCM_POV3_1 )
    #declare ESCM_POV3_1        = on;
  #end
#else
  #ifndef( ESCM_POV3_1 )
    #declare ESCM_POV3_1        = off;
  #end
#end

#declare ESCM_ModeloInterruptorPlano    = 10;

#declare ESCM_ModeloTomaCorriente       = 20;

#declare ESCM_ModeloInterruptorBola     = 30;

#declare ESCM_ModeloPortaBombilla       = 40;

#declare ESCM_TexturaPlasticaInterruptor                = texture       {
  pigment       {
    White
  }
  normal        {
    bumps
  }
}

#ifndef ( ESCM_DefaultTexturaPlasticaInterruptor )
  #declare ESCM_DefaultTexturaPlasticaInterruptor       = texture       {
    ESCM_TexturaPlasticaInterruptor
  }
#end

#declare ESCM_TexturaBotonInterruptor                   = texture       {
  pigment       {
    Gray90
  }
  normal        {
    bumps
    scale       0.01
  }
}

#ifndef ( ESCM_DefaultTexturaBotonInterruptor )
  #declare ESCM_DefaultTexturaBotonInterruptor          = texture       {
    ESCM_TexturaBotonInterruptor
  }
#end

#declare ESCM_TexturaBotonEncendidoInterruptor          = texture       {
  pigment       {
    Red         transmit        0.3
  }      
  normal        {
    agate
    scale       0.01
  }
  finish        {
    Shiny
  }
}

#ifndef ( ESCM_DefaultTexturaBotonEncendidoInterruptor )
  #declare ESCM_DefaultTexturaBotonEncendidoInterruptor = texture       {
    ESCM_TexturaBotonEncendidoInterruptor
  }
#end

#declare ESCM_TexturaBotonApagadoInterruptor            = texture       {
  pigment       {
    Yellow      transmit        0.3
  }
  normal        {
    agate
    scale       0.01
  }
  finish        {
    Shiny
  }
}

#ifndef ( ESCM_DefaultTexturaBotonApagadoInterruptor )
  #declare ESCM_DefaultTexturaBotonApagadoInterruptor   = texture       {
    ESCM_TexturaBotonApagadoInterruptor
  }
#end
            
#declare ESCM_Pigmento1 = pigment       {
  gradient      y
  scale         0.002
  triangle_wave
  pigment_map   {
    [0.5 color (0.5*Silver+0.5*Black)  ]
    [0.5 color (0.7*Silver+0.3*Black)  ]
  }
}              
            
#declare ESCM_TexturaMetalicaInterruptor                = texture       {
  pigment       {
    average
    pigment_map  {
      [ 0.5 ESCM_Pigmento1 ]
      [ 0.5 ESCM_Pigmento1 rotate 90*z ]
    }
  }
  normal        {
    average
    normal_map  {
      [ 0.5 gradient y scale 0.002 triangle_wave ]
      [ 0.5 gradient x scale 0.002 triangle_wave ]
    }
  }  
}

#ifndef ( ESCM_DefaultTexturaMetalicaInterruptor )
  #declare ESCM_DefaultTexturaMetalicaInterruptor       = texture       {
    ESCM_TexturaMetalicaInterruptor
  }
#end

#declare ESCM_TexturaPlasticaTomaCorriente              = texture       {
  pigment       {
    White
  }
  normal        {
    bumps
  }
}

#ifndef ( ESCM_DefaultTexturaPlasticaTomaCorriente )
  #declare ESCM_DefaultTexturaPlasticaTomaCorriente     = texture       {
    ESCM_TexturaPlasticaInterruptor
  }
#end

#declare ESCM_TexturaFuenteTomaCorriente                = texture       {
  pigment       {
    Wheat
  }
  normal        {
    bumps
    scale       0.01
  }
}

#ifndef ( ESCM_DefaultTexturaFuenteTomaCorriente )
  #declare ESCM_DefaultTexturaFuenteTomaCorriente       = texture     {
    ESCM_TexturaFuenteTomaCorriente
  }
#end

#declare ESCM_TexturaPlasticaAuxiliarTomaCorriente      = texture       {
  pigment       {
    White
  }
  normal        {
    agate
    scale       0.001
  }
}

#ifndef ( ESCM_DefaultTexturaPlasticaAuxiliarTomaCorriente )
  #declare ESCM_DefaultTexturaPlasticaAuxiliarTomaCorriente = texture     {
    ESCM_TexturaPlasticaAuxiliarTomaCorriente
  }
#end

#declare ESCM_TexturaMetalicaTomaCorriente              = texture       {
  pigment       {
    Gray50
  }
  normal        {
    average
    normal_map  {
      [ 0.5 gradient y scale 0.002 ramp_wave ]
      [ 0.5 gradient x scale 0.002 ramp_wave ]
    }
  }
}

#ifndef ( ESCM_DefaultTexturaMetalicaTomaCorriente )
  #declare ESCM_DefaultTexturaMetalicaTomaCorriente     = texture       {
    ESCM_TexturaMetalicaTomaCorriente
  }
#end

#declare ESCM_TexturaAuxiliarTornilloPortaBombilla      = texture       {
  pigment       {
    Yellow      transmit        0.3
  }
  normal        {
    agate
    scale       0.01
  }
  finish        {
    Shiny
  }
}

#ifndef ( ESCM_DefaultTexturaAuxiliarTornilloPortaBombilla )
  #declare ESCM_DefaultTexturaAuxiliarTornilloPortaBombilla     = 
  texture       {
    ESCM_TexturaAuxiliarTornilloPortaBombilla
  }
#end
            
#declare ESCM_TexturaPlasticaAuxiliarPortaBombilla      = texture       {
  pigment       {
    Wheat
  }
  normal        {
    bumps
    scale       0.01
  }
}

#ifndef ( ESCM_DefaultTexturaPlasticaAuxiliarPortaBombilla )
  #declare ESCM_DefaultTexturaPlasticaAuxiliarPortaBombilla = texture     {
    ESCM_TexturaPlasticaAuxiliarPortaBombilla
  }
#end

#macro ESCM_ElectricidadSigloCincoMil( Modelo, Largo, Ancho, Grueso,
                TexturaPlastica, TexturaBoton,
                TexturaBotonEncendido, TexturaBotonApagado,
                TexturaMetal, BanderaOn1, BanderaOn2 )
  #switch ( Modelo )
    #case ( ESCM_ModeloInterruptorPlano )
  union                         {
    difference                  {
      superellipsoid            {
        < 0.2 , 0.4  >
      }
      superellipsoid            {
        < 0.2 , 0.4  >
        scale   <9/50,21/78,4>
        translate       10/50*x
      }
      superellipsoid            {
        < 0.2 , 0.4  >
        scale   <9/50,21/78,4>
        translate      -10/50*x
      }
      plane                     {
        -z              , 0
      }
      scale     < Ancho, Largo, Grueso >/2      
    }
    box                         {
      <-Ancho,-Largo, 0       >/3,
      <+Ancho,+Largo,-Grueso/2>/3
    }
    union                       {
      #if ( BanderaOn1 )
        cylinder                    {
          -1/6*Largo*y-0.10*Grueso*z ,
          -1/6*Largo*y-0.51*Grueso*z ,
          0.001
          texture           {
            TexturaBotonEncendido
          }
        }
      #else
        cylinder                    {
          -1/6*Largo*y-0.10*Grueso*z ,
          -1/6*Largo*y-0.51*Grueso*z ,
          0.001
          texture           {
            TexturaBotonApagado
          }
        }
      #end
      difference                  {
        superellipsoid            {
          < 0.2 , 0.4  >
          scale   <9/50,21/78,1.0>*0.95
        }
        superellipsoid            {
          < 0.2 , 0.4  >
          scale   <20/50,21/78,1.0>*0.95
          translate       -1.00*z
        }
        scale             < Ancho, Largo, Grueso >/2
        #if ( BanderaOn1 )
          rotate         -4*x
        #else
          rotate          4*x
        #end
        translate         -2*Grueso/3*z
        texture                   {
          TexturaBoton
        }
      }
      translate         +0.1*Ancho*x
    }
    union                       {
      #if ( BanderaOn2 )
        cylinder                    {
          -1/6*Largo*y-0.10*Grueso*z ,
          -1/6*Largo*y-0.51*Grueso*z ,
          0.001
          texture           {
            TexturaBotonEncendido
          }
        }
      #else
        cylinder                    {
          -1/6*Largo*y-0.10*Grueso*z ,
          -1/6*Largo*y-0.51*Grueso*z ,
          0.001
          texture           {
            TexturaBotonApagado
          }
        }
      #end
      difference                  {
        superellipsoid            {
          < 0.2 , 0.4  >
          scale   <9/50,21/78,1.0>*0.95
        }
        superellipsoid            {
          < 0.2 , 0.4  >
          scale   <20/50,21/78,1.0>*0.95
          translate       -1.00*z
        }
        scale             < Ancho, Largo, Grueso >/2
        #if ( BanderaOn2 )
          rotate         -4*x
        #else
          rotate          4*x
        #end
        translate         -2*Grueso/3*z
        texture                   {
          TexturaBoton
        }
      }
      translate         -0.1*Ancho*x
    }
    cylinder                    {
      +12/39*Largo*y-0.10*Grueso*z       ,
      +12/39*Largo*y-0.51*Grueso*z       ,
      0.05*Ancho
      texture                   {
        TexturaMetal
      }
    }
    cylinder                    {
      -12/39*Largo*y-0.10*Grueso*z       ,
      -12/39*Largo*y-0.51*Grueso*z       ,
      0.05*Ancho
      texture                   {
        TexturaMetal
      }
    }
    texture                     {
      TexturaPlastica
    }
  }
    #break
    #case ( ESCM_ModeloInterruptorBola )
  union                         {
    #local Grueso               = Grueso*2;
    difference                  {
      superellipsoid            {
        < 0.95, 0.4  >
      }
      superellipsoid            {
        < 0.2 , 0.4  >
        scale   <18/50,42/78,4>
      }
      plane                     {
        -z              , 0
      }
      scale     < Ancho, Largo, Grueso >/2      
    }
    box                         {
      <-Ancho,-Largo, 0       >/3,
      <+Ancho,+Largo,-Grueso/2>/3
    }
    union                       {
      #if ( BanderaOn1 )
        cylinder                    {
          -3/10*Largo*y-0.10*Grueso*z ,
          -3/10*Largo*y-0.51*Grueso*z ,
          0.001
          texture           {
            TexturaBotonEncendido
          }
        }
      #else
        cylinder                    {
          -3/10*Largo*y-0.10*Grueso*z ,
          -3/10*Largo*y-0.51*Grueso*z ,
          0.001
          texture           {
            TexturaBotonApagado
          }
        }
      #end
      difference                  {
        superellipsoid            {
          < 0.2 , 0.4  >
          scale   <18/50,42/78,1.0>*0.95
        }
        superellipsoid            {
          < 0.2 , 0.4  >
          scale   <18/50,42/78,1.0>*0.95
          translate       -1.00*z
        }
        scale             < Ancho, Largo, Grueso/9.0 >/2
        #if ( BanderaOn1 )
          rotate         -4*x
        #else
          rotate          4*x
        #end
        translate         -2*Grueso/4*z
        texture                   {
          TexturaBoton
        }
      }
    }
    cylinder                    {
      +12/39*Ancho*x-0.10*Grueso*z       ,
      +12/39*Ancho*x-0.50*Grueso*z       ,
      0.05*Ancho
      texture                   {
        TexturaMetal
      }
    }
    cylinder                    {
      -12/39*Ancho*x-0.10*Grueso*z       ,
      -12/39*Ancho*x-0.50*Grueso*z       ,
      0.05*Ancho
      texture                   {
        TexturaMetal
      }
    }
    texture                     {
      TexturaPlastica
    }
  }
    #break
    #case ( ESCM_ModeloTomaCorriente )
  union                         {
    #local Grueso               = Grueso*2;
    difference                  {
      union                     {
        difference                {
          superellipsoid            {
            < 0.2 , 0.4  >
          }
          box                       {
            -2*x+0.725*y          ,
            +2*x+0.735*y-z
          }
          box                       {
            -2*x-0.725*y          ,
            +2*x-0.735*y-z
          }
        }
        superellipsoid            {
          < 0.2 , 0.4  >
          scale         <0.9,0.9,0.5>
        }
      }
      superellipsoid            {
        < 0.2 , 0.4  >
        scale   <35/50,35/78,4>
      }
      plane                     {
        -z              , 0
      }
      scale     < Ancho, Largo, Grueso >/2      
    }
    box                         {
      <-Ancho,-Largo, 0       >/2.5,
      <+Ancho,+Largo,-Grueso/2>/2.5
      texture {
        TexturaMetal
      }
    }
    difference                  {
      superellipsoid            {
        < 0.2 , 0.05  >
        scale     <Ancho,Largo,Grueso>/2
        scale   <35/50,35/78,1>*0.95
        translate -0.1*Grueso*z
      }
      box       {
        + 7/80*Largo*y-0.04*Ancho*x    ,
        + 8/80*Largo*y+0.04*Ancho*x-5*Grueso*z
        translate       Ancho/7*x
      }
      box       {
        + 7/80*Largo*y-0.04*Ancho*x    ,
        + 8/80*Largo*y+0.04*Ancho*x-5*Grueso*z
        translate      -Ancho/7*x
      }
      cylinder  {
        -Ancho/7*x+0.08*Ancho*x ,
        -Ancho/7*x+0.08*Ancho*x-5*Grueso*z      ,
        Largo/40
      }
      sphere    {
        -Ancho/7*x,
        Largo/4
        scale   <1,1,0.05>
        translate       -1.01*Grueso/2*z 
        texture         {
          TexturaBotonApagado
        }
      }
      box       {
        - 7/80*Largo*y-0.04*Ancho*x    ,
        - 8/80*Largo*y+0.04*Ancho*x-5*Grueso*z
        translate      +Ancho/7*x
      }
      box       {
        - 7/80*Largo*y-0.04*Ancho*x    ,
        - 8/80*Largo*y+0.04*Ancho*x-5*Grueso*z
        translate      -Ancho/7*x
      }
      cylinder  {
        +Ancho/7*x+0.08*Ancho*x ,
        +Ancho/7*x+0.08*Ancho*x-5*Grueso*z      ,
        Largo/40
      }
      sphere    {
        +Ancho/7*x,
        Largo/4
        scale   <1,1,0.05>
        translate       -1.01*Grueso/2*z
        texture         {
          TexturaBotonApagado
        }
      }
      plane     {
        -z      , 0
      }
      texture   {
        TexturaBotonEncendido
      }
    }
    texture                     {
      TexturaPlastica
    }
  }
    #break
    #case ( ESCM_ModeloPortaBombilla )
  union                         {
    #local RadioMayor           = Largo/2;
    #local RadioMenor           = Ancho/2;
    #local FraccionMenor        = RadioMenor/RadioMayor;
    difference                  {
      union                     {
        sor                       {
          6,
          < 1               ,-1             >,
          < 1               , 0             >,
          < ( 1*FraccionMenor+29)/30        , 0.1           >,
          < ( 7*FraccionMenor+1 )/8         , 0.5           >,
          < FraccionMenor   , 1             >,
          < FraccionMenor   , 2             >
          scale     < RadioMayor, Grueso, RadioMayor >
        }
        cylinder                {
          0             ,
          Grueso*y      ,
          RadioMenor
        }
      }
      cylinder                  {
        Grueso*0.4*y   ,
        2*Grueso*y     ,
        20/27*RadioMenor
        texture         {
          TexturaBoton
        }
      }
      cylinder                {
        0               ,
        Grueso*y        ,
        RadioMenor
        scale         <0.5,1.0,0.2>*0.75
        translate     +2*RadioMayor/3*x-0.1*Grueso*y
      }
      cylinder                {
        0               ,
        Grueso*y        ,
        RadioMenor
        scale         <0.5,1.0,0.2>*0.75
        translate     -2*RadioMayor/3*x-0.1*Grueso*y
      }
      cylinder                {
        0               ,
        Grueso*y        ,
        RadioMenor
        scale         <0.5,1.0,0.2>
        translate     +2*RadioMayor/3*x+0.1*Grueso*y
      }
      cylinder                {
        0               ,
        Grueso*y        ,
        RadioMenor
        scale         <0.5,1.0,0.2>
        translate     -2*RadioMayor/3*x+0.1*Grueso*y
      }
    }
    union                       {
      difference                {
        cylinder                {
          Grueso*0.1*y  ,
          Grueso*y*0.95 ,
          RadioMenor*0.95*20/27
        }
        cylinder                {
          Grueso*0.1*y  ,
          1.1*Grueso*y  ,
          RadioMenor*0.90*20/27
        }
      }
      #local C                  = 0;
      #local TotalTorus         = 5;
      #while ( C < TotalTorus )
        torus                   {
          RadioMenor*0.925*20/27 ,
          RadioMenor*0.05
          translate     ( 0.1+0.8*C/TotalTorus )*Grueso*y
        }
        #local C                = C+1;
      #end
      difference                {
        cylinder                {
          0.21*y*Grueso   ,
          0.41*y*Grueso   ,
          RadioMenor*20/27
        }
        box                     {
          <-0.1*RadioMenor,-1,-1>,
          <1,1,1>
        }
      }
      cylinder                  {
        0.21*y*Grueso+0.2*RadioMenor*x  ,
        0.41*y*Grueso+0.2*RadioMenor*x  ,
        0.2*RadioMenor
        texture                 {
          TexturaBotonEncendido
        }
      }
      rotate    1
      texture                   {
        TexturaMetal
      }
    }
    texture                     {
      TexturaPlastica
    }
  }
    #break
  #end
#end

#macro ESCM_Interruptor( BanderaOn1, BanderaOn2 )
  object                {
    #local L            = ESCM_L;
    #local Largo        = 78*L;
    #local Ancho        = 50*L;
    #local Grueso       =  5*L;
    ESCM_ElectricidadSigloCincoMil( ESCM_ModeloInterruptorPlano,
        Largo, Ancho, Grueso,
        ESCM_DefaultTexturaPlasticaInterruptor,
        ESCM_DefaultTexturaBotonInterruptor,
        ESCM_DefaultTexturaBotonEncendidoInterruptor,
        ESCM_DefaultTexturaBotonApagadoInterruptor,
        ESCM_DefaultTexturaMetalicaInterruptor, BanderaOn1, BanderaOn2 )
  }
#end

#macro ESCM_InterruptorBola( BanderaOn )
  object                {
    #local L            = ESCM_L;
    #local Largo        = 39*L;
    #local Ancho        = 25*L;
    #local Grueso       = 15*L;
    ESCM_ElectricidadSigloCincoMil( ESCM_ModeloInterruptorBola,
        Largo, Ancho, Grueso,
        ESCM_DefaultTexturaPlasticaInterruptor,
        ESCM_DefaultTexturaBotonInterruptor,
        ESCM_DefaultTexturaBotonEncendidoInterruptor,
        ESCM_DefaultTexturaBotonApagadoInterruptor,
        ESCM_DefaultTexturaMetalicaInterruptor, BanderaOn, on )
  }
#end

#macro ESCM_TomaCorriente( )
  object                {
    #local L            = ESCM_L;
    #local Largo        = 50*L;
    #local Ancho        = 78*L;
    #local Grueso       = 2.5*L;
    ESCM_ElectricidadSigloCincoMil( ESCM_ModeloTomaCorriente,
        Largo, Ancho, Grueso,
        ESCM_DefaultTexturaPlasticaTomaCorriente,
        0,
        ESCM_DefaultTexturaPlasticaAuxiliarTomaCorriente,
        ESCM_DefaultTexturaFuenteTomaCorriente,
        ESCM_DefaultTexturaMetalicaTomaCorriente, on, on )
  }
#end

#macro ESCM_PortaBombilla( )
  object                {
    #local L            = ESCM_L;
    #local Largo        = 82*L;
    #local Ancho        = 27*L;
    #local Grueso       = 29*L;
    ESCM_ElectricidadSigloCincoMil( ESCM_ModeloPortaBombilla,
        Largo, Ancho, Grueso,
        ESCM_DefaultTexturaPlasticaInterruptor,
        ESCM_DefaultTexturaPlasticaAuxiliarPortaBombilla,
        ESCM_DefaultTexturaAuxiliarTornilloPortaBombilla,
        0,
        ESCM_DefaultTexturaMetalicaInterruptor, on, on )
  }
#end



