// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 10 Octubre 2011
//
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El paquete ESCM.inc, ofrece los dibujos
// de interruptores, toma corriente y portabombilla simple
// ESCM_Interruptor( BanderaOn1, BanderaOn2 )
//      BanderaOn1      : on/off interruptor hacia x+
//      BanderaOn2      : on/off interruptor hacia x-
//              78*L Largo 50*L Alto
//              Frente :  5*L hacia z-
//              Descansa sobre el plano XY parte posterior lisa
// ESCM_InterruptorBola( BanderaOn )
//      BanderaOn       : on/off (encendido/apagado)
//              25*L Ancho 39*L Alto
//              Frente : 16*L hacia z-
//              Descansa sobre el plano XY parte posterior lisa
// ESCM_TomaCorriente()
//              78*L Largo 50*L Alto
//              Frente : 2.5*L
//              Descansa sobre el plano XY parte posterior lisa
// ESCM_PortaBombilla()
//              Radio   : 82*L
//              Alto    : 30*L hacia y+ parte posterior lisa
//              Descansa sobre el plano XZ parte posterior lisa
// Se ofrece la siguiente macro de texturas
// #macro ESCM_ElectricidadSigloCincoMil( Modelo, Largo, Ancho, Grueso,
//                TexturaPlastica, TexturaBoton,
//                TexturaBotonEncendido, TexturaBotonApagado,
//                TexturaMetal, BanderaOn1, BanderaOn2 )
//      Modelo          : se ofrecen las siguientes opciones
//              ESCM_ModeloInterruptorPlano
//              ESCM_ModeloInterruptorBola
//              ESCM_ModeloTomaCorriente
//              ESCM_ModeloPortaBombilla
//      Largo           : Aproxima la dimension en x total,
//      Ancho           : Aproxima la dimension en y total
//              excepto en el Portabombilla, que se refiere
//              al diametro del cilindro central
//      Grueso          : Relacionado con la dimension en z-
//              excepto en ESCM_ModeloPortaBombilla que es y+
//      TexturaPlastica : Textura Plastica principal a aplicar
//              a las estructuras
//      TexturaBoton    :
//              ESCM_ModeloInterruptorPlano  Boton
//              ESCM_ModeloInterruptorBola   Boton
//              ESCM_ModeloTomaCorriente     no aplica
//              ESCM_ModeloPortaBombillo     Interior plastico
//      TexturaBotonEncendido   :
//              ESCM_ModeloInterruptorPlano  Boton on
//              ESCM_ModeloInterruptorBola   Boton on
//              ESCM_ModeloTomaCorriente     Soporte plastico secundario
//              ESCM_ModeloPortaBombillo     Tornillo interior
//      TexturaBotonApagado     :
//              ESCM_ModeloInterruptorPlano  Boton off
//              ESCM_ModeloInterruptorBola   Boton off
//              ESCM_ModeloTomaCorriente     zona circular de conexion
//              ESCM_ModeloPortaBombillo     no aplica
//      TexturaMetalica         :
//              Para aplicar a zonas metalicas,
//              en el toma corriente, es el fondo oscuro.
//      BanderaOn1              :
//              Primera bandera de encendido para los interruptores
//              Interruptor en x+ si hay dos
//      BanderaOn2              :
//              Segunda bandera de encendido, util unicamente
//              para ESCM_ModeloInterruptorPlano interruptor en x-
//
// Las siguientes variables no deberian modificarse
// #declare ESCM_TexturaPlasticaInterruptor             = texture...
//      Textura plastica principal de las cuatro figuras
// #declare ESCM_TexturaBotonInterruptor                = texture...
//      Textura a aplicar a los botones de los interruptores
// #declare ESCM_TexturaBotonEncendidoInterruptor       = texture...
//      Textura a aplicar a la senal de encendido de los botones
// #declare ESCM_TexturaBotonApagadoInterruptor         = texture...
//      Textura a aplicar a la senal de apagado de los botones
// #declare ESCM_TexturaMetalicaInterruptor             = texture...
//      Textura metalica a aplicar a tornillos externos
//      tambien se aplica al contacto cilndrico de bombillo
// #declare ESCM_TexturaPlasticaTomaCorriente           = texture...
//      Textura plastica a aplicar al toma corriente
// #declare ESCM_TexturaFuenteTomaCorriente             = texture...
//      Textura para la zona lisa del contacto electrico
// #declare ESCM_TexturaPlasticaAuxiliarTomaCorriente   = texture...
//      Textura para el soporte plastico secundario
// #declare ESCM_TexturaMetalicaTomaCorriente           = texture...
//      Textura de fondo oscura
// #declare ESCM_TexturaAuxiliarTornilloPortaBombilla   = texture...
//      Textura de tornillo interior del portabombilla
// #declare ESCM_TexturaPlasticaAuxiliarPortaBombilla   = texture...
//      Textura plastica al interior del portabombilla
//
// La siguiente es la lista de los modificadores permitidos,
//      que tendran efecto en las macros default
// #declare ESCM_POV3_1         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1,
//      en algunas versiones se activa automaticamente
// #declare ESCM_DefaultTexturaPlasticaInterruptor              = texture...
//      Default modificable de Textura
//      plastica principal de las cuatro figuras
// #declare ESCM_DefaultTexturaBotonInterruptor                 = texture...
//      Default modificable de Textura
//      a aplicar a los botones de los interruptores
// #declare ESCM_DefaultTexturaBotonEncendidoInterruptor        = texture...
//      Default modificable de Textura
//      a aplicar a la senal de encendido de los botones
// #declare ESCM_DefaultTexturaBotonApagadoInterruptor          = texture...
//      Default modificable de Textura
//      a aplicar a la senal de apagado de los botones
// #declare ESCM_DefaultTexturaMetalicaInterruptor              = texture...
//      Default modificable de Textura metalica a aplicar
//      a tornillos externos
//      tambien se aplica al contacto cilindrico de bombillo
// #declare ESCM_DefaultTexturaPlasticaTomaCorriente            = texture...
//      Default modificable de Textura plastica a aplicar al toma corriente
// #declare ESCM_DefaultTexturaFuenteTomaCorriente              = texture...
//      Default modificable de
//      Textura para la zona lisa del contacto electrico
// #declare ESCM_DefaultTexturaPlasticaAuxiliarTomaCorriente    = texture...
//      Default modificable de Textura para el soporte plastico secundario
// #declare ESCM_DefaultTexturaMetalicaTomaCorriente            = texture...
//      Default modificable de Textura de fondo oscura
// #declare ESCM_DefaultTexturaAuxiliarTornilloPortaBombilla    = texture...
//      Default modificable de Textura de tornillo interior del portabombilla
// #declare ESCM_DefaultTexturaPlasticaAuxiliarPortaBombilla    = texture...
//      Default modificable de Textura plastica al interior del portabombilla
//
// Para colocarlo simplemente
// #include "ESCM.inc"
// object { ESCM_Interruptor( on, off ) }
//
// Para el uso de la macro de texturas:
// #include "ESCM.inc"
// object {
//   ESCM_ElectricidadSigloCincoMil( GMGE_ModeloInterruptorPlano,
//                0.078, 0.05, 0.005, PinkAlabaster,
//                Rust, PinkAlabaster, PinkAlabaster,
//                PinkAlabaster, on, off }
//
// Otro ejemplo con modificador
// #include "ESCM.inc"
// #declare ESCM_DefaultTexturaPlasticaTomaCorriente    = texture {
//   average
//   texture_map        {
//     [ 0.5 Rust                               ]
//     [ 0.5 ESCM_TexturaPlasticaTomaCorriente  ]
//   }
// }
// object       { ESCM_TomaCorriente() }
//

#include "colors.inc"

#local   OjoAbsoluto            = 256;
#local   VecesCentroAbsoluto    = 10;
#local   L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 100  , 100   , -3000 >*L
         White
}

background      {
         Gray50
}    

#include "ESCM.inc"

#local FactorAcercamiento       = 6.5;

union                   {
  object                {
    ESCM_Interruptor( on, off )
    translate     +75*L*x+50*L*y
  }
  object          {
    ESCM_InterruptorBola( on )
    translate     -75*L*x+50*L*y
  }
  object          {
    ESCM_TomaCorriente()
    translate     +75*L*x-50*L*y
  }
  object          {
    ESCM_PortaBombilla()
    rotate        -90*x
    translate     -75*L*x-50*L*y
  }
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z
}


