// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escaz, San Jos, Costa Rica
// dedicado a Jess y Mara...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 15 febrero 2011
//                
// Mis dibujos estn en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// El objeto MSCS_Mesa() tiene las siguientes caracteristicas
// Alto         : 581*L
// Ancho        : 686*L
// Largo        : 1329*L
// SeparacionPatas      : 520*L--786*L (grueso 50*L)
//   Se coloca con la parte inferior centrada en el origen
//   orientado segn el eje X, zona superior y+
// El objeto MSCS_Silla() tiene las siguientes caracteristicas
// Alto         : 771*L
// Alto Asiento : 322*L
// Base Asiento : 278*L--278*L mas exceso de unos 12 a 20*L
// El respaldo del asiento es ligeramente curvo.
//   Se coloca con la parte inferior centrada en el origen
//   orientado segn frente en x+, superior en y+
// La macro MSCS_MesaSillas(), coloca una mesa con seis sillas
//   a cada silla se le aplica rotaciones y un translate del tipo
//   322*L en z a las sillas laterales
//   o bien 615*L en x a las sillas extremas
//   mas alguna aleatoriedad
//
// Para su uso simplemente, utilice una macro default.
// #include "MSCS.inc"
// object       { MSCS_MesaSillas() }
// O bien, MSCS_Mesa() o MSCS_Silla()
//
// Se pueden accesar las macros directamente para modificacin de texturas
// #macro MSCS_MacroMesa ( TexturaMadera )
//      TexturaMadera   : textura que recubrir enteramente al objeto
// #macro MSCS_MacroSilla( TexturaMadera, TexturaTela )
//      TexturaMadera   : recubre la madera de la silla
//      TexturaTela     : cubre el respaldo y el asiento de la silla
//
// Las texturas predefinidas, que no deberan modificarse son
// MSCS_TexturaMadera   : textura predefinida de la madera
// MSCS_TexturaTela     : textura predefinida de la tela
// El objeto permite los siguientes modificadorse
// #declare MSCS_POV3_1                         = off;
//      si se activa con "on" realiza modificaciones de compatibilidad
//      para ejectuar con POVRay3.1.  En algunas versiones de POVRay
//      se activar automticamente.
// #declare MSCS_TexturaMaderaDefault           = texture {...}
//      permite modificar la madera default del objeto
// #declare MSCS_TexturaTelaDefault             = texture {...}
//      permite modificar la tela default del objeto
// Ejemplo:  
// #include "MSCS.inc"
// #declare MSCS_TexturaTelaDefault             = texture       {
//       average
//       texture_map    {
//          [ 0.5 MSCS_TexturaTela ]
//          [ 0.5 TexturaCustom... ]
//       }
// }
// object       { MSCS_Silla() }
//

#include "colors.inc"

#local   L                      = 0.001;
#local   OjoAbsoluto            = 256*L;
#local   VecesCentroAbsoluto    = 10;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "MSCS.inc"

object  {
  MSCS_MesaSillas()
  translate     -0.5*y
}

