// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 26 diciembre 2011
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
// El objeto creado por la macro WHFT_VentanaGrande
// es una ventana de terraza grande.  Se ubica
// segun las siguientes coordenadas:
// Minimo <  -774,      0,  -35 >*L
// Maximo <   774,   1233,  106 >*L
// el origen se encuentra debajo del centro inferior del marco
// Si se elimina la reja metalica, las dimensiones serian
// Minimo <  -774,      0,  -35 >*L
// Maximo <   774,   1233,   35 >*L
//
// Una ventana de menor dimension se consigue con WHFT_VentanaTerraza
// Minimo <  -519,      0,  -35 >*L
// Maximo <   519,    890,  106 >*L
//
// En la macro mas elaborada, cada nueva fila agrega AltoNivelExtra,
// y cada nueva columna agrega AnchoNivel
//
// Para crear el objeto, es probable se necesite perforar una
// pared.  Esto se puede realizar por diferencia con
// WHFT_ContainerDifferenceWHFT
// que contiene el marco de profundidad doble en Z.
// por ejemplo
// union        {
//   difference {
//      "ParedCustom..."
//      WHFT_ContainerDifferenceWHFT
//   }
//   WHFT_VentanaTerraza( 0.1, true )
// }
// La macro seria para una ventada de 2*2 vidrios
// WHFT_VentanaTerraza( FraccionVidrio, BanderaReja )
//   FraccionVidrio       = de 0.0 a 1.0, cerrado... hasta 90 grados.
//      Se aplica a la ventana inferior derecha.
//   BanderaReja          = true con rejas, false las elimina
//
// Una ventana de mayores dimensiones 3*3 vidrios se consigue con
// #macro WHFT_VentanaGrande
//        ( FraccionVidrio1, FraccionVidrio2, FraccionVidrio3, BanderaReja )
//   FraccionVidrio1      = de 0.0 a 1.0, cerrado... hasta 90 grados
//              se aplica al vidrio inferior central.
//   FraccionVidrio2      = de 0.0 a 1.0, cerrado... hasta 90 grados
//              se aplica al vidrio superior izquierdo.
//   FraccionVidrio3      = de 0.0 a 1.0, cerrado... hasta 90 grados
//              se aplica al vidrio superior derecho.
//   BanderaReja          = true con rejas, false las elimina.
//
// La siguiente macro permite crear ventanales, con un mayor
// control sobre el detalle
// #macro WHFT_WindowHouseFrontTerrace
//        ( AltoNivel, AltoNivelExtra, AnchoNivel, ProfundidadNivel,
//          GruesoNivel, NivelesFila, NivelesColumna,
//          BarrasHorizontales, BarrasVerticales,
//          ArregloFraccion, ArregloTextura, BanderaReja )
//   AltoNivel            = alto del primer nivel de ventanas.
//   AltoNivelExtra       = alto de las siguientes filas de ventanas.
//   AnchoNivel           = frente de una columna de vidrios.
//   ProfundidadNivel     = Ancho de la madera de soporte de los vidrio
//      generalmente menor al grueso verdadero de la pared.
//   GruesoNivel          = grueso de la madera divisoria.
//   NivelesFila          = total de filas horizontales de ventanas.
//   NivelesColumna       = total de columnas verticales de vidrios.
//   BarrasHorizontales   = total de barras horizontales del enrejado,
//              sin contar el borde.
//   BarrasVerticales     = total de barras verticales del enrejado,
//              sin contar el borde.
//   ArregloFraccion      = array [ NivelesFila*NivelesColumna ],
//              contiene una lista de numeros reales.
//              Ingrese un valor de -2, para un vidrio liso.
//              Caso contrario, una fraccion de 0.0 a 1.0,
//              cerrado, hasta... 90 grados.  Orden de izquierda a derecha,
//              para luego ascender por fila.
//   ArregloTextura       = array [ NivelesFila*NivelesColumna ],
//              contiene una lista de texturas, que se aplicara
//              en cada vidrio.  Orden de izquerda a derecha,
//              para luego ascender por fila.
//   BanderaReja          = true con rejas, false las elimina .
//
// acepta los siguientes modificadores (si se indica es default) 
//   #declare WHFT_POV3_1                       = off;
//                      para asegurar compatibilidad con POVRay 3.1.
//                      Innecesario en version actual.
//                      Se recomienda su uso para
//                      versiones futuras del objeto (activa con on).
//   #declare WHFT_FactorContainerDifference    = 1.0;
//                      permite aumentar la profundidad en pared
//                      de WHFT_ContainerDifferenceWHFT para
//                      paredes de mayor grosor.
//                      El valor default produce el doble del marco.
//   #declare WHFT_TexturaContainerDifference   = texture { ... }
//                      cuando se define esta variable, se aplica
//                      textura por diferencia a 
//                      WHFT_ContainerDifferenceWHFT.
//                      Puede ser util para pintar el interior
//                      de paredes, de color diferente que el exterior.
//   #declare WHFT_TexturaMarcoVentana          = texture { ... }
//                      se aplica en el marco .
//   #declare WHFT_TexturaVidrioVentana         = texture { ... }
//                      se aplica en la mayoria de vidrios.
//   #declare WHFT_TexturaVidrioRectangular     = texture { ... }
//                      se aplica en el vidrio superior central
//                      de la ventana grande.
//   #declare WHFT_TexturaSujetaVidrio          = texture { ... }
//                      se aplica en el soporte de las laminas
//                      rectangulares, directamente
//                      a ambos lados de los vidrio.
//   #declare WHFT_TexturaSujetaSujetaVidrio    = texture { ... }
//                      soporte metalico en ambas laterales de los
//                      vidrios rectangulares.
//   #declare WHFT_TexturaRejaMetalica          = texture { ... }
//                      textura para la reja.
// Para usarlo es suficiente
// #include "WHFT.inc"
// object       {
//   WHFT_VentanaTerraza(0.0,true)
// }
//
// con una macro algo mas compleja
// #declare MyVentanal  = array [2] { -2, 0.5 }
// #declare MyTextura   = array [2] { WHFT_TesturaVidrioVentana,
//                              WHFT_TexturaVidrioRectangular }
// object       {
//    WHFT_WindowHouseFrontTerrace
//        ( 0.532, 0.343, 0.511, 0.035, 0.060,
//          1, 1, 9, 5, MyVentanal, MyTextura, false )
// }
//
// un ejemplo con modificadores
// #declare WHFT_TexturaMarcoVentana    = texture { PinkAlabaster }
// #include "WHFT.inc"
// object       {
//   WHFT_VentanaTerraza(0.0,true)
// }
//

#include "colors.inc"
#declare WHFT_OjoAbsoluto            = 256;
#declare WHFT_VecesCentroAbsoluto    = 10;
#declare WHFT_L                      = 0.001;

camera {
        location  <   0,  0, 
                -( WHFT_VecesCentroAbsoluto+1 )*WHFT_OjoAbsoluto >*WHFT_L
        direction z
        sky       y
        angle     38.74
}         
light_source    {
         < 500  , 500   , -4000 >*WHFT_L
         White
}
light_source    {
         <-500  , 500   , -4000 >*WHFT_L
         White
}
background      {
         Cyan*0.8
}

#include "WHFT.inc"

object  {
  WHFT_VentanaGrande( 0.3, 0.6, 0.1, true )
  rotate        30*y
  translate     250*WHFT_L*z-600*WHFT_L*y
}

